/*
 * asteroid.h
 * 
 * Copyright 2012 Alexander Andrejevic <theflash@sdf.lonestar.org>
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 */

#ifndef _ASTEROID_H_
#define _ASTEROID_H_

#include <GL/gl.h>
#include "model3D.h"

typedef struct
{
	GLfloat ambient_light[4];
	GLfloat diffuse_light[4];
	GLfloat specular_light[4];
	GLfloat light_loc[4];
} LIGHT;

typedef struct
{
	GLfloat material_ambient[4];
	GLfloat material_diffuse[4];
	GLfloat material_specular[4];
	GLfloat material_emission[4];
	GLfloat shininess;
} MATERIAL;

class asteroid
{
private:
	LIGHT lighting;
	MATERIAL material;
	float rot_x, rot_y, rot_z;
	float delta_rot_x, delta_rot_y, delta_rot_z;
	int g_level;
	model3D *g_model;
	GLuint expl_texture;
	int timeout;
public:
	bool exists;
	bool explosion;
	float x, y, z, size;
	float strength;
	asteroid(int level, model3D *model, GLuint expl_tex);
	~asteroid();
    void draw();
	bool move(int ms);
	bool laser_hit(float intensity);
	void explode();
};

#endif
