/*
 * model3D.h
 * 
 * Copyright 2012 Alexander Andrejevic <theflash@sdf.lonestar.org>
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 */

#ifndef _MODEL3D_H_
#define _MODEL3D_H_

#include <vector>
#include <GL/gl.h>
#include <GL/glu.h>

#define PI 3.14159265358979f

using namespace std;

typedef struct
{
	GLfloat x, y, z;
} VERTEX, NORMAL;

class model3D
{
private:
	GLuint model_list;
	vector <VERTEX> vertices;
	vector <NORMAL> normals;
	vector <vector <pair <int, int> > > faces;
public:
	model3D(const char *file_path);
	~model3D();
	void draw_model(float x, float y, float z, float size, float rot_x, float rot_y, float rot_z);
};

#endif
