/*
 * tga_loader.h
 * 
 * Copyright 2012 Alexander Andrejevic <theflash@sdf.lonestar.org>
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 */

#ifndef _TGA_LOADER_H_
#define _TGA_LOADER_H_

typedef struct
{
	unsigned char id_length, color_map_type, image_type;
	unsigned short color_map_first_entry, color_map_length;
	unsigned char color_map_entry_size;
	unsigned short x, y, width, height;
	unsigned char pixel_depth, image_descriptor;
} __attribute__((__packed__)) TGA_HEADER;

class tga_image
{
public:
	unsigned char *data;
	unsigned short width, height;
	unsigned char bpp;
	tga_image(const char *file_path);
	~tga_image();
};

#endif
